/*
 * Instance.h
 * 
 * Copyright (C) 2008 Matthias Schiffer <matthias@gamezock.de>
 * 
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ZOOMEDIT_INSTANCE_H_
#define ZOOMEDIT_INSTANCE_H_

#include <gtkmm/main.h>
#include <libglademm/xml.h>

namespace ZoomEdit {

namespace Gui {
class Window;
}

class Instance {
  public:
    virtual ~Instance();
    
    static bool create();
    
  private:
    static guint instances;
    
    Glib::RefPtr<Gnome::Glade::Xml> xml;
    Gui::Window *window;
    
    Instance();
    
    void destroy();
    
    // Prevent shallow copy
    Instance(const Instance &o);
    Instance& operator=(const Instance &o);
};

}

#endif /*ZOOMEDIT_INSTANCE_H_*/
